; Program       : UCOMCRY.ASM
; Function      : A little COM - crypter with very smart 
;                 anti-debugging/-analysing/-heuristic code
;                 done for my PAiN - article.
; Author        : UniquE                                    
; Date          : 25.07.1997                                
; Copyright     : (c) 1997 by UniquE     email: UniquE@buemplizer.ch
                                                            
MODEL           TINY                    ; tiny code         
.286                                    ; i80286 CPU        
CODESEG                                                     
ORG             100h                    ; entry point is CS:0100h
                                                            
Define_FileName EQU     "COMFILE.COM",0 ; defines the filename of the COM file
Define_OutName  EQU     "CRYPTED.COM",0 ; the output - file 
                                                            
                                                            
Start:                                                      
                call    Load_COM_File   ; We have to load, ...
                call    Crypt_COM_File  ; to crypt ...      
                call    Save_COM_File   ; and to save the COM file.
                exitcode                ; EXIT to DOS                                                
                                                            
; ***************************************************************************                                                                   
; ******************* Loading the COM - File [start] ************************
Load_COM_File:                                              
                mov     ah, 09h         ; display a textstring
                lea     dx, Message     ; the "AVE!" - message                      
                int     21h                                   
                                                              
	        mov    	ax, 3D02h  	; open the COM file (Read/Write)
	        lea	dx, File_Name   ; filename at DS:DX             
	        int	21h
	        xchg	ax, bx		; move filehandler to BX
                jnc     ReadFile        ; Error? No => read the file!   
                                                                        
                mov     ah, 09h         ; display a textstring          
                lea     dx, Open_Error  ; errormessage                  
                int     21h                                             
                exitcode                ; EXIT to DOS                   
                                                                        
        ReadFile:                                                       
   	        mov	ah, 3Fh	      	; read the file (handler in BX) 
            	mov	cx, 60000d      ; we won't crypt files > 60000 bytes
        	lea	dx, COM_Start   ; the buffer (DS:DX) is at COM_Start
        	int 	21h                                                  
        	jc      R_Error         ; carry - flag? Yes => Read Error!   
        	                                                             
        	cmp     ax, 0000h       ; not ONE lousy byte read?           
            	je      R_Error         ; yes => nothing to do (=Read Error)!
                                                                             
                mov     COM_Size, ax    ; save the filesize for later use    
                                                                        
                mov     ah, 3Eh         ; close the file                
                int     21h                                             
                                                                        
                ret                     ; leave the sub-routine              
                                                                             
        R_Error:                                                        
                mov     ah, 09h         ; display a textstring          
                lea     dx, Read_Error  ; errormessage                  
                int     21h                                             
                exitcode                ; EXIT to DOS                   
                                                                        
                                                                        
Message         db "A simple COM - crypter done for PAiN", 13, 10
                db "(c) 1997 by UniquE", 13, 10
                db "UniquE@buemplizer.ch", 13, 10, 13, 10, "$"
Open_Error      db "Error opening "     ; errormessages
File_Name       db Define_FileName                                      
                db 10, 13, "$"                                          
Read_Error      db "Read error.", 13, 10, "$"
COM_Size        dw ?, ?                 ; the filesize of the COM       
; ********************* Loading the COM - File [end] ************************
; ***************************************************************************                                                                   
                                                  
                                                                        
                                                                        
; ***************************************************************************                                                                   
; *********** Write the crypted COM back to a file [start] ******************
Save_COM_File:                                                          
                mov     ah, 3Ch         ; create a file                 
                xor     cx, cx          ; no file attribs               
                lea     dx, Output_File ; ASCIIZ - string of the filename
                int     21h                                             
                jc      Write_Error     ; error? Yes => exit!               
                                                                        
                xchg    ax, bx          ; move filehandler to BX        
                                                                         
                mov     ah, 40h         ; write to file                 
                mov     cx, Offset Decrypt_End - Offset Decrypt_Start   
                add     cx, COM_Size    ; calculate the bytes to write  
                lea     dx, COM_Start                                   
                int     21h                                             
                jc      Write_Error     ; error? Yes => exit!               
                                                                        
                mov     ah, 3Eh         ; close the file                
                int     21h                                             
                jc      Write_Error     ; error? Yes => exit!               
                                                                        
                mov     ah, 09h         ; display a textstring          
                lea     dx, File_Written; "File written."               
                int     21h                                             
                ret                     ; leave the sub-routine         
                                                                        
        Write_Error:                                                    
                mov     ah, 09h         ; display a textstring          
                lea     dx, File_Error  ; "Can't write file!"
                int     21h                                             
                ret                     ; leave the sub-routine         
                                                                        
                                                                        
Output_File     db      Define_OutName  ; "CRYPTED.COM"                 
File_Error      db      "Can't write the crypted file!", 10, 13, "$"
File_Written    db      "File written. OK.", 13, 10, "$"
; ************ Write the crypted COM back to a file [end] *******************
; ***************************************************************************                                                                   
                                                                        
                                                                        
                                                                        
; ***************************************************************************                                                                   
; ********** Encrypt the COM file and calculate the JMPs [start] ************
Crypt_COM_File:                                                         
                push    ds              ; save some registers           
                push    es                                              
                                                                        
                ; save the first three bytes                            
                mov     ax, Word Ptr [Offset COM_Start]                 
                mov     bl, Byte Ptr [Offset COM_Start + 2]             
                mov     Saved_Byte_1_2, ax                              
                mov     Saved_Byte_3, bl                                
                                                                        
                ; write a JMP to our code at the begin of the file      
                mov     Byte Ptr [Offset COM_Start], 0E9h ; JMP ....    
                mov     ax, COM_Size    ; we start at the end of the old COM
                add     ax, (Offset New_Entry_Point - Offset Decrypt_Start) -3
                mov     Word Ptr [Offset COM_Start + 1], ax             
                                                                        
                ; define the length of the encrypted code               
                shr     ax, 1           ; div AX by 2 (we encrypt in WORDs)
                mov     Crypt_Length, ax; adjust length of the decrypt-loop
                                                                         
                                                                         
                ; RANDOM (?) key for the encryption                      
                mov     ah, 2Ch         ; get the system time           
                int     21h                                             
                xor     dl, dh          ; "Shake it, baby!"             
                add     dl, ch                                          
                rol     dx, cl                                          
                xor     cx, dx                                          
                                                                        
                mov     Decrypt_Key, cx ; define the decryption key     
                                                                        
                ; now, we copy the decrypter to the end of the buffer   
                push    cs              ; prepare for the MOVSB command:
                push    cs              ; CX bytes form DS:SI will be   
                pop     ds              ; moved to ES:DI                
                pop     es              ; ES = DS = CS                  
                                                                        
                mov     si, Offset Decrypt_Start ; copy the decrypter to ...
                mov     di, Offset COM_Start     ; the end of the read-buffer
                add     di, COM_Size                                    
                                        ; copy the whole decrypter      
                mov     cx, Offset Decrypt_End - Offset Decrypt_Start   
                cld                     ; increment-direction for SI and DI
                rep     movsb           ; copy NOW!                     
                                                                        
                ; encrypt the COM with a poor XOR - loop                
                mov     cx, Crypt_Length; get the length for the encryption
                mov     bp, Offset COM_Start + 3  ; begin _after_ the JMP!
                mov     bx, Decrypt_Key ; get the encryption - key      
                                                                        
        Encrypt_Loop:                                                         
                xor     Word Ptr[bp], bx; encrypt NOW!
                add     bp, 02h         ; to the next word...           
                loop    Encrypt_Loop    ; encrypt all!                        
                                                                              
                pop     es              ; restore the saved registers         
                pop     ds                                                    
                ret                     ; leave the sub-routine               
; *********** Encrypt the COM file and calculate the JMPs [end] *************
; *************************************************************************** 
                                        
                                        
                                        
; ***************************************************************************                                                                   
; ************************* The decryptor [start] ***************************
Decrypt_Start:                          
                ; Restore the original COM file                               
mov_W_Ptr_100   db      0C7h, 06h, 00h, 01h      ; (MOV WORD PTR [100], ....) 
Saved_Byte_1_2  dw      ?               ; the first two original bytes        
mov_B_Ptr_102   db      0C6h, 06h, 02h, 01h      ; (MOV BYTE PTR [102], ..)   
Saved_Byte_3    db      ?               ; the third original byte             
                                                                              
                pop     es              ; restore all registers         
                popa                                                     
                int     3
                push    0100h           ; push the original CS:IP to stack
                ret                     ; return to the original COM now!
                                                                        
                db      0E9h            ; hide the next instructions    
New_Entry_Point:                        ; here is the new IP             
                pusha                   ; save all registers             
                push    es                                               
                                                                         
                ; Here comes a real "UniquE" peace of                    
                ; anti-debugging/-analysing/-heuristic/-unpacking code: 
                cli                     ; interrupts OFF                
                in      al, 64h         ; keyboard OFF                        
                or      al, 040h                                                             
                out     64h, al                                                              
                                                                        
                mov     ax, 0040h       ; BIOS segment address          
                mov     es, ax          ; ES = 0040h
                ; Copy some code in a memory area who's always free,
                ; the keyboard buffer :). This code 'll be written:
                ;    pop   bx             <= get IP (the UniquE way!)
                ;    inc   bx             <= adjust for the IRET
                ;    inc   bx            
                ;    push  bx            
                ;    sub   bx, COM_Size   <= execute an important instruction
                ;    iret                 <= leave the keyboardbuffer
                                         
                mov     Word Ptr es:[0020h], 0435Bh ; We write CODE in
                mov     Word Ptr es:[0022h], 05343h ; the keyboard buffer!                    
                mov     Word Ptr es:[0024h], 0EB81h                       
mov_es_24       db      26h, 0C7h, 06h, 26h, 00h ; (MOV WORD PTR ES:[0024], .)
Length_of_COM   dw      (Offset Division_Position - Offset Decrypt_Start) + 2
                mov     Byte Ptr es:[0028h], 0CFh                         
                                                                          
                                                                          
                xor     ax, ax          ; change the INT-table at 0000:0000
                mov     es, ax                                            
                mov     cx, es:[0000h]  ; save the INT 00h handler
                push    cx                                                
                mov     cx, es:[0002h]                                       
                push    cx                                                
                                                                          
                mov     Word Ptr es:[0002h], 0040h  ; Set segment...             
                mov     Word Ptr es:[0000h], 0020h  ; and offset of the new
                                                    ; INT handler.
                                                    
Division_Position:                                  
                div     ax              ; AX = 0000h => division by ZERO!
                                        ; ==> INT 00h call!!            
                ; BX points now to "New_Entry_Point:".                     
                                                                        
                pop     cx              ; restore the old INT 00h handler
                mov     es:[0002h], cx
                pop     cx            
                mov     es:[0000h], cx
                        
                in      al, 64h         ; keyboard ON                   
                and     al, 0BFh                                        
                out  	64h, al                                         
                sti                     ; interrupts ON                                                  
                                                                              
                                                                        
mov_cx          db      0B9h            ; move to CX (MOV CX, ....)     
                                        ; the length of the crypted code   
Crypt_Length    dw      (Offset New_Entry_Point - Offset Decrypt_Start) / 2
                mov     bp, 101h        ; decryption begins at CS:0101h 
                                                                        
                push    bx              ; save the IP for the next RET  
                add     bx, (Offset New_Entry_Point - Offset Decrypt_Start)
Decrypt_Loop:                                                           
xor_word_ptr_bp db      081h, 076h, 00h ; decrypt (XOR WORD PTR [BP], ...)
Decrypt_Key     dw      0DEADh          ; ... with the decryption key
                inc     bp              ; go to the next position       
                inc     bp                                              
                cmp     bp, bx          ; everything decrypted?         
                jna     Decrypt_Loop    ; no. => continue!              
                                                                        
                ret                     ; jump to "Decrypt_Start:"      
Decrypt_End:                                                            
; ************************* The decrypter [end] *****************************
; *************************************************************************** 
                                                                        
                                                                        
COM_Start:                              ; start of the read - buffer    
                                                                        
end             Start                   ; start the program at "Start:" 
